#ifndef __NLL_CONFIG_H_INCLUDED__
#define __NLL_CONFIG_H_INCLUDED__

#ifdef USE_FLOATING_POINT
#define NLL_FLOATING_POINT
#endif

#ifdef USE_SYSTEM_FUNCTION
#define NLL_SYSTEM_FUNCTION
#endif
#ifdef USE_SYSCALL_FUNCTION
#define NLL_SYSCALL_FUNCTION
#endif

/* #define NLL_MEMORY_STATIC */

/* #define NLL_LOGICAL_OPERATOR_ORDER */

#define NLL_MULTIBYTE_NAME
#define NLL_LABEL_ARGUMENTS
/* #define NLL_STDIO_FUNCTION */
#define NLL_TYPECHANGE_ENABLE
/* #define NLL_VECTOR_POSTFIX */
#define NLL_COMMAND_NEED_SPACE

/* #define NLL_TERM_DISABLE */

#ifdef WIN32
#define NLL_OUTPUT_NOWAIT
#endif

#if defined(USE_GRAPHIC_SDL1) || defined(USE_GRAPHIC_SDL2)
#define USE_GRAPHIC_SDL
#endif
#ifdef USE_GRAPHIC_SDL2
#define USE_GRAPHIC_SDL_RENDERER
#endif

#define LINE_MAXLEN 256
#define LINE_MAXNUM 1024

#define SYMBOL_NAMELEN 32

#define LABEL_NAMELEN SYMBOL_NAMELEN
#define LABEL_MAXNUM 256

#define VARIABLE_NAMELEN SYMBOL_NAMELEN
#define VARIABLE_MAXNUM 256

#define VALUE_MAXNUM 4096

#define STRING_MAXLEN 256
#define STRING_MAXNUM 256

#define ELEMENT_MAXNUM 1024

#define FUNCTION_RETVAL_MAXNUM  8
#define LABELCALL_RETVAL_MAXNUM 8

#define COMMAND_MAXNUM 1024
#define COMMAND_ARG_MAXNUM 4
#define COMMAND_ARG_WORD_MAXLEN 16

#define POSITION_MAXNUM 64

#define ARRAY_MAXNUM 1024

#define AREA_SIZE 4096

#define STACK_MAXNUM 64

#define FRAMEBUF_MAXWIDTH       120
#define FRAMEBUF_MAXHEIGHT       60
#define FRAMEBUF_DEFAULT_WIDTH   40
#define FRAMEBUF_DEFAULT_HEIGHT  25

#define GRAPHIC_MAXWIDTH       4096
#define GRAPHIC_MAXHEIGHT      4096
#define GRAPHIC_DEFAULT_WIDTH   640
#define GRAPHIC_DEFAULT_HEIGHT  480

#define GRAPHIC_IMAGE_MAXNUM 1024

#endif
